; 
    include \masm32\include\masm32rt.inc
    .586
    include timers.asm

    _fiadd PROTO :DWORD,:DWORD
    _add PROTO :DWORD,:DWORD
    __add PROTO :DWORD,:DWORD
; 
    .data
        array dd 1000 dup(1)
    .code
; 
start:
; 
    invoke _fiadd, ADDR array, 1000
    print ustr$(eax), 32
    invoke _add, ADDR array, 1000
    print ustr$(eax), 32
    invoke __add, ADDR array, 1000
    print ustr$(eax), 13,10

    LOOP_COUNT EQU 200000
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke _fiadd, ADDR array, 1000    
    counter_end
    print ustr$(eax)," cycles", 13, 10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke _add, ADDR array, 1000    
    counter_end
    print ustr$(eax)," cycles", 13, 10

    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      invoke __add, ADDR array, 1000    
    counter_end
    print ustr$(eax)," cycles", 13, 10

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 

align 4

_fiadd proc uses esi arr:DWORD,cnt:DWORD
    LOCAL iSum:DWORD
    mov   ecx, cnt
    dec   ecx
    mov   esi, arr
    finit
    fild  DWORD PTR[esi]
  @@:
    add   esi, 4
    fiadd DWORD PTR[esi]
    loop  @B
    fistp iSum
    fwait
    mov   eax, iSum
    ret
_fiadd endp

align 4

_add proc uses esi arr:DWORD,cnt:DWORD
    mov   ecx, cnt
    dec   ecx
    mov   esi, arr
    mov   eax, [esi]
  @@:
    add   eax,[esi]
    loop  @B
    ret
_add endp

; The optimization technique used here was borrowed
; from the MASM32 arradd procedure.
align 4
__add proc arr:DWORD,cnt:DWORD
    mov   ecx, cnt
    mov   edx, arr
    add   ecx, ecx
    xor   eax, eax
    add   ecx, ecx
    add   edx, ecx
    neg   ecx
    jmp   @F
  align 16
  @@:
    add   eax,[edx+ecx]
    add   ecx, 4
    jnz   @B
    ret
__add endp

; 
end start
 